	
InstSehFrame MACRO ContinueAddr
	PUSH EBP;ERR+14h save ebp (being ebp at safe-place) 
	PUSH 0  ;ERR+10h area for flags 
	PUSH 0  ;ERR+0Ch information for handler 
	PUSH OFFSET ContinueAddr;ERR+8h new eip at safe-place
	PUSH OFFSET SehHandler  ;ERR+4h address of handler
	ASSUME FS : NOTHING  
	PUSH FS:[0]	            ;ERR+0h keep next ERR up the chain 
	MOV  FS:[0], ESP        ;point to ERR just made on the stack 
ENDM

KillSehFrame MACRO
	POP  FS:[0]
	ADD  ESP, 4;restore next ERR up the chain
ENDM

.CODE
SehHandler PROC C  pExcept:DWORD,pFrame:DWORD,pContext:DWORD,pDispatch:DWORD
	MOV EAX,pExcept
	assume eax:ptr EXCEPTION_RECORD
	.if [EAX].ExceptionCode==STATUS_STACK_OVERFLOW
		MOV  EAX, pContext
		ASSUME EAX : PTR CONTEXT
		MOV ECX,pFrame		 
		PUSH [ECX+8];get safe place given in ERR structure
		POP  [EAX].regEip;insert new eip 
		PUSH [ECX];get pointer to ERR structure 
		POP  [EAX].regEsp;use it as new esp 
		PUSH [ECX+14h];get ebp at safe place given in ERR 
		POP [EAX].regEbp;insert new ebp 
		mov eax,ExceptionContinueExecution;go to safe place - return eax=0 
	.else
		MOV EAX,ExceptionContinueSearch
	.endif	
	RET
SehHandler ENDP